#include <avr/io.h>
#include <util/delay.h>
#include <avr/interrupt.h>

#define MOTOR_PIN_0 PB3
#define MOTOR_PIN_1 PB4
#define MOTOR_ENABLE PB1
#define BUTTON PB2

void start_motor() {
    PORTB |= (1 << MOTOR_ENABLE);
}

void stop_motor(){
    PORTB &= ~(1 << MOTOR_ENABLE);
}

void toggle_motor_dir(){
    PORTB ^= (1 << MOTOR_PIN_0) | (1 << MOTOR_PIN_1);
}

void init_motor(){
    DDRB |= (1 << MOTOR_PIN_0) | (1 << MOTOR_PIN_1) | (1 << MOTOR_ENABLE);

    PORTB |= (1 << MOTOR_PIN_0);
    PORTB &= ~(1 << MOTOR_PIN_1);

    stop_motor();
}

void init_button(){
    // Input pullup
    DDRB &= ~(1 << BUTTON);
    PORTB |= (1 << BUTTON);
}

int main(void){
    init_motor();
    init_button();

    start_motor();
    _delay_ms(1000);

    while(1){
        if(!(PINB & (1 << BUTTON))){
            stop_motor();
            _delay_ms(5000);
            toggle_motor_dir();
            start_motor();
            _delay_ms(1000);
        }
    }
}
